import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import ReactDOM from 'react-dom';
import Tether from 'tether';
import lodash from 'lodash';
import { isInViewport } from './utils';

function noop() {}

var FoundationTether = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(FoundationTether, _React$PureComponent);

  var _super = _createSuper(FoundationTether);

  function FoundationTether(props) {
    var _this;

    _classCallCheck(this, FoundationTether);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "child", void 0);

    _defineProperty(_assertThisInitialized(_this), "onResize", void 0);

    _defineProperty(_assertThisInitialized(_this), "tether", void 0);

    _defineProperty(_assertThisInitialized(_this), "tetherElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "getOptions", function () {
      var overrides = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return _objectSpread({
        element: _this.tetherElement,
        target: _this.props.target(),
        attachment: 'top left',
        targetAttachment: 'bottom left'
      }, overrides);
    });

    _defineProperty(_assertThisInitialized(_this), "setOrientation", function () {
      if (_this.tether === null) {
        return;
      }

      if (_this.tetherElement !== null && _this.props.width !== null) {
        _this.tetherElement.style.width = _this.props.width;
      } // try right orientation.


      _this.tether.setOptions(_this.getOptions({
        attachment: 'top left',
        targetAttachment: 'bottom left'
      }));

      var node = _this.child;

      if (node === null) {
        return;
      }

      if (!isInViewport(node)) {
        // try left orientation.
        _this.tether.setOptions(_this.getOptions({
          attachment: 'top right',
          targetAttachment: 'bottom right'
        }));

        if (!isInViewport(node)) {
          // try middle orientation.
          _this.tether.setOptions(_this.getOptions({
            attachment: 'top middle',
            targetAttachment: 'bottom middle'
          }));
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onRef", function (c) {
      _this.child = c;
    });

    _this.child = null;
    _this.onResize = null;
    _this.tether = null;
    _this.tetherElement = null;
    var element = document.querySelector(props.tetherTo); // this is mainly to support testing, should probably warn in browser if condition is met.

    if (element === null) {
      return _possibleConstructorReturn(_this);
    }

    _this.tetherElement = document.createElement('div');
    _this.tetherElement.className = 'foundation-tether';
    element.appendChild(_this.tetherElement);
    return _this;
  }

  _createClass(FoundationTether, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.tetherElement === null) {
        return;
      }

      this.tether = new Tether(this.getOptions());
      this.onResize = lodash.throttle(this.setOrientation, 250);
      window.addEventListener('resize', this.onResize);
      this.setOrientation();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.tetherElement === null) {
        return;
      }

      this.setOrientation();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.tetherElement === null || this.tether === null) {
        return;
      }

      if (this.onResize !== null) {
        window.removeEventListener('resize', this.onResize);
        this.onResize.cancel();
      }

      this.tether.destroy();

      if (this.tetherElement.parentNode !== null) {
        this.tetherElement.parentNode.removeChild(this.tetherElement);
      }

      this.tetherElement = null;
      this.child = null;
    }
  }, {
    key: "render",
    value: function render() {
      if (this.tetherElement === null) {
        return null;
      }

      return /*#__PURE__*/ReactDOM.createPortal( /*#__PURE__*/React.createElement("div", {
        ref: this.onRef
      }, this.props.children), this.tetherElement);
    }
  }]);

  return FoundationTether;
}(React.PureComponent);

_defineProperty(FoundationTether, "defaultProps", {
  children: null,
  target: noop,
  tetherTo: '.foundation-normalize',
  width: null
});

export default FoundationTether;
//# sourceMappingURL=FoundationTether.js.map